# 🔥🛠️ Foundry Gas Diff Reporter

- Easily compare gas reports generated by Foundry automatically on each of your Pull Requests!

## How it works

Everytime somebody opens a Pull Request, the action expects [Foundry](https://github.com/foundry-rs/foundry) `forge` to run a test suite, generating a gas report to a temporary file (named `gasreport.ansi` by default).

Once generated, the action will fetch the comparative gas report stored as an artifact from previous runs; parse & compare them, storing the results in the action's outputs as shell and as markdown.

You can then do whatever you want with the results!

> **Our recommandation:** Automatically submit a sticky comment displaying the gas diff!

### ⚠️ v3.9+ is no longer working with the latest release of Foundry. Please use v3.10+ if a message displays "Is this a Foundry gas report?"

## Live Example

---

### Changes to gas cost

> Generated at commit: [d62d23148ca73df77cd4378ee1b3c17f1f303dbf](/Rubilmax/foundry-gas-diff/commit/d62d23148ca73df77cd4378ee1b3c17f1f303dbf)

#### 🧾 Summary (10% most significant diffs)

| Contract                      | Method                                                                                                                                                                                                                                                      |                                                                                                                               Avg (+/-) |                                                                                                                                                  % |
| :---------------------------- | :---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------------------------: | -------------------------------------------------------------------------------------------------------------------------------------------------: |
| **Morpho contract**           | _borrow(address,uint256)_<br />_claimToTreasury_<br />_liquidate_<br />_marketStatus_<br />_repay(address,uint256)_<br />_setP2PIndexCursor_<br />_supply(address,address,uint256,uint256)_<br />_supply(address,uint256)_<br />_withdraw(address,uint256)_ | -43,939 ✅<br />+3,963 ❌<br />-69,325 ✅<br />+622 ❌<br />-22,934 ✅<br />+25,350 ❌<br />+402,561 ❌<br />-22,356 ✅<br />-15,968 ✅ | **-7.91%**<br />**+46.86%**<br />**-21.50%**<br />**+53.99%**<br />**-8.94%**<br />**+512.43%**<br />**+2898.00%**<br />**-6.03%**<br />**-6.02%** |
| **PositionsManager contract** | _supplyLogic_                                                                                                                                                                                                                                               |                                                                                                                              -21,036 ✅ |                                                                                                                                         **-5.76%** |

---

<details>
<summary><strong>Full diff report</strong> 👇</summary>
<br />

| Contract                          |     Deployment Cost (+/-) | Method                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  Min (+/-) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               % |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        Avg (+/-) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     % |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    Median (+/-) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               % |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                Max (+/-) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           % |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           # Calls (+/-) |
| :-------------------------------- | ------------------------: | :-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | -----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------: |
| **Morpho contract**               | 3,381,129&nbsp;(+113,744) | _borrow(address,uint256)_<br />_borrow(address,uint256,uint256)_<br />_borrowBalanceInOf_<br />_cEth_<br />_claimRewards_<br />_claimToTreasury_<br />_createMarket_<br />_defaultMaxGasForMatching_<br />_deltas_<br />_enteredMarkets_<br />_getEnteredMarkets_<br />_getNext_<br />_initialize_<br />_interestRatesManager_<br />_isClaimRewardsPaused_<br />_lastPoolIndexes_<br />_liquidate_<br />_marketParameters_<br />_marketStatus_<br />_maxSortedUsers_<br />_p2pBorrowIndex_<br />_p2pSupplyIndex_<br />_positionsManager_<br />_repay(address,address,uint256)_<br />_repay(address,uint256)_<br />_rewardsManager_<br />_setDefaultMaxGasForMatching_<br />_setIncentivesVault_<br />_setInterestRatesManager_<br />_setMaxSortedUsers_<br />_setP2PIndexCursor_<br />_setPositionsManager_<br />_setReserveFactor_<br />_setRewardsManager_<br />_setTreasuryVault_<br />_supply(address,address,uint256)_<br />_supply(address,address,uint256,uint256)_<br />_supply(address,uint256)_<br />_supplyBalanceInOf_<br />_treasuryVault_<br />_updateP2PIndexes_<br />_wEth_<br />_withdraw(address,uint256)_<br />_withdraw(address,uint256,address)_ | 13,703&nbsp;(+9,785)<br />11,078&nbsp;(-382,423)<br />894&nbsp;(0)<br />405&nbsp;(0)<br />5,871&nbsp;(0)<br />1,194&nbsp;(+22)<br />2,736&nbsp;(+22)<br />568&nbsp;(-67)<br />1,050&nbsp;(0)<br />616&nbsp;(+22)<br />1,256&nbsp;(+22)<br />1,057&nbsp;(+22)<br />3,765&nbsp;(-45)<br />471&nbsp;(+22)<br />443&nbsp;(+44)<br />742&nbsp;(0)<br />11,771&nbsp;(+7,706)<br />669&nbsp;(0)<br />774&nbsp;(+22)<br />373&nbsp;(+22)<br />593&nbsp;(+22)<br />591&nbsp;(+22)<br />493&nbsp;(+22)<br />8,542&nbsp;(-517)<br />13,873&nbsp;(+9,949)<br />471&nbsp;(+22)<br />1,113&nbsp;(-66)<br />2,695&nbsp;(0)<br />2,673&nbsp;(+44)<br />621&nbsp;(+44)<br />2,717&nbsp;(-2,230)<br />2,697&nbsp;(+67)<br />2,717&nbsp;(-67)<br />2,631&nbsp;(0)<br />2,629&nbsp;(0)<br />469,051&nbsp;(-4,937)<br />11,502&nbsp;(-2,389)<br />13,923&nbsp;(+10,006)<br />980&nbsp;(+44)<br />493&nbsp;(+22)<br />1,766&nbsp;(-45)<br />2,426&nbsp;(+22)<br />5,649&nbsp;(+1,772)<br />327,424&nbsp;(-8,284) | **+249.74%**<br />**-97.18%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**+1.88%**<br />**+0.81%**<br />**-10.55%**<br />**0.00%**<br />**+3.70%**<br />**+1.78%**<br />**+2.13%**<br />**-1.18%**<br />**+4.90%**<br />**+11.03%**<br />**0.00%**<br />**+189.57%**<br />**0.00%**<br />**+2.93%**<br />**+6.27%**<br />**+3.85%**<br />**+3.87%**<br />**+4.67%**<br />**-5.71%**<br />**+253.54%**<br />**+4.90%**<br />**-5.60%**<br />**0.00%**<br />**+1.67%**<br />**+7.63%**<br />**-45.08%**<br />**+2.55%**<br />**-2.41%**<br />**0.00%**<br />**0.00%**<br />**-1.04%**<br />**-17.20%**<br />**+255.45%**<br />**+4.70%**<br />**+4.67%**<br />**-2.48%**<br />**+0.92%**<br />**+45.71%**<br />**-2.47%** | 511,848&nbsp;(-43,939)<br />453,367&nbsp;(+4,279)<br />1,410&nbsp;(-14)<br />655&nbsp;(-10)<br />162,715&nbsp;(+28)<br />12,420&nbsp;(+3,963)<br />259,951&nbsp;(-802)<br />568&nbsp;(-67)<br />2,171&nbsp;(-77)<br />834&nbsp;(+22)<br />1,514&nbsp;(+25)<br />1,127&nbsp;(+22)<br />247,044&nbsp;(+84)<br />476&nbsp;(+23)<br />443&nbsp;(+44)<br />914&nbsp;(-5)<br />253,108&nbsp;(-69,325)<br />1,079&nbsp;(-21)<br />1,774&nbsp;(+622)<br />373&nbsp;(+22)<br />705&nbsp;(+18)<br />710&nbsp;(+18)<br />493&nbsp;(+22)<br />57,644&nbsp;(-2,020)<br />233,500&nbsp;(-22,934)<br />676&nbsp;(+18)<br />7,779&nbsp;(-872)<br />23,750&nbsp;(+19)<br />5,732&nbsp;(+62)<br />4,598&nbsp;(+49)<br />30,297&nbsp;(+25,350)<br />5,756&nbsp;(+85)<br />42,724&nbsp;(-1,062)<br />21,643&nbsp;(+25)<br />23,553&nbsp;(+39)<br />469,051&nbsp;(-4,937)<br />416,452&nbsp;(+402,561)<br />348,636&nbsp;(-22,356)<br />1,181&nbsp;(+35)<br />1,293&nbsp;(+22)<br />22,820&nbsp;(-2,300)<br />2,426&nbsp;(+22)<br />249,208&nbsp;(-15,968)<br />327,424&nbsp;(-8,284) | **-7.91%**<br />**+0.95%**<br />**-0.98%**<br />**-1.50%**<br />**+0.02%**<br />**+46.86%**<br />**-0.31%**<br />**-10.55%**<br />**-3.43%**<br />**+2.71%**<br />**+1.68%**<br />**+1.99%**<br />**+0.03%**<br />**+5.08%**<br />**+11.03%**<br />**-0.54%**<br />**-21.50%**<br />**-1.91%**<br />**+53.99%**<br />**+6.27%**<br />**+2.62%**<br />**+2.60%**<br />**+4.67%**<br />**-3.39%**<br />**-8.94%**<br />**+2.74%**<br />**-10.08%**<br />**+0.08%**<br />**+1.09%**<br />**+1.08%**<br />**+512.43%**<br />**+1.50%**<br />**-2.43%**<br />**+0.12%**<br />**+0.17%**<br />**-1.04%**<br />**+2898.00%**<br />**-6.03%**<br />**+3.05%**<br />**+1.73%**<br />**-9.16%**<br />**+0.92%**<br />**-6.02%**<br />**-2.47%** | 398,171&nbsp;(-236,518)<br />430,755&nbsp;(-8,480)<br />894&nbsp;(0)<br />405&nbsp;(0)<br />177,285&nbsp;(+22)<br />7,913&nbsp;(+2,917)<br />254,459&nbsp;(-930)<br />568&nbsp;(-67)<br />1,050&nbsp;(0)<br />889&nbsp;(+22)<br />1,530&nbsp;(+22)<br />1,130&nbsp;(+22)<br />247,904&nbsp;(-45)<br />471&nbsp;(+22)<br />443&nbsp;(+44)<br />742&nbsp;(0)<br />379,725&nbsp;(-8,991)<br />669&nbsp;(0)<br />1,774&nbsp;(+1,022)<br />373&nbsp;(+22)<br />593&nbsp;(+22)<br />591&nbsp;(+22)<br />493&nbsp;(+22)<br />11,007&nbsp;(-1,471)<br />148,456&nbsp;(-17,582)<br />471&nbsp;(+22)<br />8,238&nbsp;(-66)<br />23,878&nbsp;(0)<br />5,732&nbsp;(+62)<br />4,598&nbsp;(+49)<br />4,881&nbsp;(-66)<br />5,756&nbsp;(+85)<br />2,717&nbsp;(-67)<br />21,814&nbsp;(0)<br />23,812&nbsp;(0)<br />469,051&nbsp;(-4,937)<br />540,732&nbsp;(+526,841)<br />345,216&nbsp;(-49,628)<br />980&nbsp;(+44)<br />493&nbsp;(+22)<br />21,822&nbsp;(-2,657)<br />2,426&nbsp;(+22)<br />182,413&nbsp;(-2,833)<br />327,424&nbsp;(-8,284) | **-37.27%**<br />**-1.93%**<br />**0.00%**<br />**0.00%**<br />**+0.01%**<br />**+58.39%**<br />**-0.36%**<br />**-10.55%**<br />**0.00%**<br />**+2.54%**<br />**+1.46%**<br />**+1.99%**<br />**-0.02%**<br />**+4.90%**<br />**+11.03%**<br />**0.00%**<br />**-2.31%**<br />**0.00%**<br />**+135.90%**<br />**+6.27%**<br />**+3.85%**<br />**+3.87%**<br />**+4.67%**<br />**-11.79%**<br />**-10.59%**<br />**+4.90%**<br />**-0.79%**<br />**0.00%**<br />**+1.09%**<br />**+1.08%**<br />**-1.33%**<br />**+1.50%**<br />**-2.41%**<br />**0.00%**<br />**0.00%**<br />**-1.04%**<br />**+3792.68%**<br />**-12.57%**<br />**+4.70%**<br />**+4.67%**<br />**-10.85%**<br />**+0.92%**<br />**-1.53%**<br />**-2.47%** | 1,084,878&nbsp;(-14,126)<br />926,748&nbsp;(+244,864)<br />4,894&nbsp;(0)<br />2,405&nbsp;(0)<br />314,724&nbsp;(+66)<br />23,501&nbsp;(-35)<br />305,124&nbsp;(-2,270)<br />568&nbsp;(-67)<br />9,050&nbsp;(0)<br />889&nbsp;(+22)<br />2,911&nbsp;(+22)<br />1,193&nbsp;(+22)<br />247,904&nbsp;(-45)<br />2,471&nbsp;(+22)<br />443&nbsp;(+44)<br />2,742&nbsp;(0)<br />546,086&nbsp;(-10,768)<br />2,669&nbsp;(0)<br />2,774&nbsp;(+22)<br />373&nbsp;(+22)<br />2,593&nbsp;(+22)<br />2,591&nbsp;(+22)<br />493&nbsp;(+22)<br />200,020&nbsp;(-4,621)<br />2,293,327&nbsp;(-8,768)<br />2,471&nbsp;(+22)<br />10,238&nbsp;(-66)<br />23,878&nbsp;(0)<br />8,791&nbsp;(+79)<br />8,576&nbsp;(+55)<br />108,709&nbsp;(+103,762)<br />8,815&nbsp;(+102)<br />108,692&nbsp;(-2,679)<br />21,814&nbsp;(0)<br />23,812&nbsp;(0)<br />469,051&nbsp;(-4,937)<br />697,123&nbsp;(+683,232)<br />2,095,559&nbsp;(-5,545)<br />4,980&nbsp;(+44)<br />2,493&nbsp;(+22)<br />51,876&nbsp;(-2,657)<br />2,426&nbsp;(+22)<br />1,930,391&nbsp;(-13,111)<br />327,424&nbsp;(-8,284) | **-1.29%**<br />**+35.91%**<br />**0.00%**<br />**0.00%**<br />**+0.02%**<br />**-0.15%**<br />**-0.74%**<br />**-10.55%**<br />**0.00%**<br />**+2.54%**<br />**+0.76%**<br />**+1.88%**<br />**-0.02%**<br />**+0.90%**<br />**+11.03%**<br />**0.00%**<br />**-1.93%**<br />**0.00%**<br />**+0.80%**<br />**+6.27%**<br />**+0.86%**<br />**+0.86%**<br />**+4.67%**<br />**-2.26%**<br />**-0.38%**<br />**+0.90%**<br />**-0.64%**<br />**0.00%**<br />**+0.91%**<br />**+0.65%**<br />**+2097.47%**<br />**+1.17%**<br />**-2.41%**<br />**0.00%**<br />**0.00%**<br />**-1.04%**<br />**+4918.52%**<br />**-0.26%**<br />**+0.89%**<br />**+0.89%**<br />**-4.87%**<br />**+0.92%**<br />**-0.67%**<br />**-2.47%** | 331&nbsp;(+74)<br />43&nbsp;(+3)<br />519&nbsp;(-1)<br />24&nbsp;(+1)<br />17&nbsp;(0)<br />5&nbsp;(-5)<br />1,717&nbsp;(+223)<br />4&nbsp;(+3)<br />214&nbsp;(+7)<br />5&nbsp;(0)<br />87&nbsp;(-1)<br />36&nbsp;(0)<br />284&nbsp;(+37)<br />2,546&nbsp;(+401)<br />1&nbsp;(0)<br />347&nbsp;(-2)<br />32&nbsp;(+4)<br />156&nbsp;(+3)<br />4&nbsp;(-6)<br />1&nbsp;(0)<br />482&nbsp;(+2)<br />453&nbsp;(0)<br />1&nbsp;(0)<br />4&nbsp;(0)<br />69&nbsp;(+5)<br />2,829&nbsp;(+438)<br />39&nbsp;(+10)<br />285&nbsp;(+37)<br />2&nbsp;(0)<br />4&nbsp;(0)<br />4&nbsp;(+3)<br />2&nbsp;(0)<br />21&nbsp;(0)<br />286&nbsp;(+37)<br />287&nbsp;(+37)<br />1&nbsp;(0)<br />3&nbsp;(+2)<br />673&nbsp;(+165)<br />476&nbsp;(0)<br />5&nbsp;(0)<br />1,313&nbsp;(+3)<br />1&nbsp;(0)<br />93&nbsp;(+8)<br />1&nbsp;(0) |
| **PositionsManager contract**     | 4,592,720&nbsp;(+291,600) | _borrowLogic_<br />_liquidateLogic_<br />_repayLogic_<br />_supplyLogic_<br />_withdrawLogic_                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       556&nbsp;(-147,533)<br />1,046&nbsp;(-1,855)<br />679&nbsp;(0)<br />759&nbsp;(+22)<br />657&nbsp;(0) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      **-99.62%**<br />**-63.94%**<br />**0.00%**<br />**+2.99%**<br />**0.00%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           503,082&nbsp;(-39,042)<br />247,375&nbsp;(-82,027)<br />219,166&nbsp;(-25,060)<br />344,282&nbsp;(-21,036)<br />244,934&nbsp;(-20,058) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          **-7.20%**<br />**-24.90%**<br />**-10.26%**<br />**-5.76%**<br />**-7.57%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            426,548&nbsp;(-15,648)<br />376,224&nbsp;(-8,359)<br />141,582&nbsp;(-19,981)<br />342,120&nbsp;(-53,095)<br />178,893&nbsp;(-2,526) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    **-3.54%**<br />**-2.17%**<br />**-12.37%**<br />**-13.43%**<br />**-1.39%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             1,081,377&nbsp;(-13,795)<br />542,584&nbsp;(-10,136)<br />2,289,787&nbsp;(-8,443)<br />2,092,034&nbsp;(-5,214)<br />1,926,871&nbsp;(-12,804) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  **-1.26%**<br />**-1.83%**<br />**-0.37%**<br />**-0.25%**<br />**-0.66%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               374&nbsp;(+79)<br />32&nbsp;(+5)<br />73&nbsp;(+6)<br />677&nbsp;(+169)<br />94&nbsp;(+9) |
| **InterestRatesManager contract** |    845,047&nbsp;(+38,239) | _updateP2PIndexes_                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               618&nbsp;(0) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       **0.00%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             24,182&nbsp;(-3,004) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           **-11.05%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            20,674&nbsp;(-2,612) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     **-11.22%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      102,527&nbsp;(-320) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  **-0.31%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       2,551&nbsp;(+237) |
| **RewardsManager contract**       |          972,578&nbsp;(0) | _accrueUserBorrowUnclaimedRewards_<br />_accrueUserSupplyUnclaimedRewards_<br />_claimRewards_<br />_compBorrowerIndex_<br />_compSupplierIndex_<br />_getLocalCompBorrowState_<br />_getLocalCompSupplyState_<br />_initialize_                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      2,107&nbsp;(0)<br />2,129&nbsp;(0)<br />20,828&nbsp;(+88)<br />708&nbsp;(0)<br />731&nbsp;(0)<br />826&nbsp;(0)<br />849&nbsp;(0)<br />2,753&nbsp;(0) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             **0.00%**<br />**0.00%**<br />**+0.42%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**0.00%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    23,043&nbsp;(-185)<br />28,068&nbsp;(+27)<br />68,539&nbsp;(-36)<br />1,088&nbsp;(-64)<br />912&nbsp;(-29)<br />1,270&nbsp;(-89)<br />1,071&nbsp;(-44)<br />68,914&nbsp;(+35) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            **-0.80%**<br />**+0.10%**<br />**-0.05%**<br />**-5.56%**<br />**-3.08%**<br />**-6.55%**<br />**-3.95%**<br />**+0.05%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        23,802&nbsp;(0)<br />25,824&nbsp;(0)<br />67,447&nbsp;(+71)<br />708&nbsp;(0)<br />731&nbsp;(0)<br />826&nbsp;(0)<br />849&nbsp;(0)<br />69,148&nbsp;(0) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             **0.00%**<br />**0.00%**<br />**+0.11%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**0.00%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                     56,277&nbsp;(0)<br />57,058&nbsp;(0)<br />182,933&nbsp;(-2,066)<br />2,708&nbsp;(0)<br />2,731&nbsp;(0)<br />2,826&nbsp;(0)<br />2,849&nbsp;(0)<br />69,148&nbsp;(0) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         **0.00%**<br />**0.00%**<br />**-1.12%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**0.00%**<br />**0.00%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        669&nbsp;(+93)<br />959&nbsp;(+174)<br />24&nbsp;(0)<br />21&nbsp;(+3)<br />22&nbsp;(+3)<br />18&nbsp;(+3)<br />18&nbsp;(+3)<br />284&nbsp;(+37) |
| **IncentivesVault contract**      |    623,575&nbsp;(-17,019) | _tradeCompForMorphoTokens_                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               443&nbsp;(0) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       **0.00%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                33,621&nbsp;(-51) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            **-0.15%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               36,308&nbsp;(-78) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      **-0.21%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        65,565&nbsp;(-86) |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                  **-0.13%** |                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              6&nbsp;(0) |

</details>

---

## Getting started

### Automatically generate a gas report diff on every PR

Add a workflow (`.github/workflows/foundry-gas-diff.yml`):

```yaml
name: Report gas diff

on:
  push:
    branches:
      - main
  pull_request:
    # Optionally configure to run only for changes in specific files. For example:
    # paths:
    # - src/**
    # - test/**
    # - foundry.toml
    # - remappings.txt
    # - .github/workflows/foundry-gas-diff.yml

jobs:
  compare_gas_reports:
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@v3
        with:
          submodules: recursive

      - name: Install Foundry
        uses: onbjerg/foundry-toolchain@v1
        with:
          version: nightly

      # Add any step generating a gas report to a temporary file named gasreport.ansi. For example:
      - name: Run tests
        run: forge test --gas-report > gasreport.ansi # <- this file name should be unique in your repository!
        env:
          # make fuzzing semi-deterministic to avoid noisy gas cost estimation
          # due to non-deterministic fuzzing (but still use pseudo-random fuzzing seeds)
          FOUNDRY_FUZZ_SEED: 0x${{ github.event.pull_request.base.sha || github.sha }}

      - name: Compare gas reports
        uses: Rubilmax/foundry-gas-diff@v3.11
        with:
          summaryQuantile: 0.9 # only display the 10% most significant gas diffs in the summary (defaults to 20%)
          sortCriteria: avg,max # sort diff rows by criteria
          sortOrders: desc,asc # and directions
          ignore: test-foundry/**/* # filter out gas reports from specific paths (test/ is included by default)
        id: gas_diff

      - name: Add gas diff to sticky comment
        if: github.event_name == 'pull_request' || github.event_name == 'pull_request_target'
        uses: marocchino/sticky-pull-request-comment@v2
        with:
          # delete the comment in case changes no longer impact gas costs
          delete: ${{ !steps.gas_diff.outputs.markdown }}
          message: ${{ steps.gas_diff.outputs.markdown }}
```

> :information_source: **An error will appear at first run!**<br/>
> 🔴 <em>**Error:** No workflow run found with an artifact named "main.gasreport.ansi"</em><br/>
> As the action is expecting a comparative file stored on the base branch and cannot find it (because the action never ran on the target branch and thus has never uploaded any gas report)

## Options

### `report` _{string}_

This should correspond to the path of a file where the output of forge's gas report has been logged.
Only necessary when generating multiple gas reports on the same repository.

⚠️ Make sure this file uniquely identifies a gas report, to avoid messing up with a gas report of another workflow on the same repository!

_Defaults to: `gasreport.ansi`_

### `base` _{string}_

The gas diff reference branch name, used to fetch the previous gas report to compare the freshly generated gas report to.

_Defaults to: `${{ github.base_ref || github.ref_name }}`_

### `head` _{string}_

The gas diff target branch name, used to upload the freshly generated gas report.

_Defaults to: `${{ github.head_ref || github.ref_name }}`_

### `token` _{string}_

The github token allowing the action to upload and download gas reports generated by foundry. You should not need to customize this, as the action already has access to the default Github Action token.

_Defaults to: `${{ github.token }}`_

### `header` _{string}_

The top section displayed in the markdown output. Can be used to identify multiple gas diffs in the same PR or add metadata/information to the markdown output.

_Defaults to:_

```markdown
# Changes to gas cost
```

### `summaryQuantile` _{number}_

The quantile threshold to filter avg gas cost diffs to display in the summary top section.

_Defaults to: `0.8`_

### `sortCriteria` _{string[]}_

A list of criteria to sort diff rows by in the report table (can be `name | min | avg | median | max | calls`), separated by a comma.
Must have the same length as sortOrders.

_Defaults to: name_

### `sortOrders` _{string[]}_

A list of directions to sort diff rows by in the report table (can be `asc | desc`), for each sort criterion, separated by a comma.
Must have the same length as sortCriteria.

_Defaults to: asc_

### `ignore` _{string[]}_

The list of contract paths from which to ignore gas reports, separated by a comma.
This allows to clean out gas diffs from dependency contracts impacted by a change (e.g. Proxies, ERC20, ...).

_No default assigned: optional opt-in (Please note that node dependencies are always discarded from gas reports)_

### `match` _{string[]}_

The list of contract paths of which only to keep gas reports, separated by a comma.
This allows to only display gas diff of specific contracts.

_No default assigned: optional opt-in_

## ⚠️ Known limitations

> **Library gas reports**<br/>
> Forge does not generate library gas reports. You need to wrap their usage in a contract calling the library to be able to compare gas costs of calling the library.

> **Average gas cost estimation**<br/>
> Average & median gas costs for each function is estimated based on the test suite, which means they are easily impacted by small changes in the tests. We recommend using a separate, specific test suite, rarily updated, designed to perform accurate gas estimations.

> **Fuzzing impacts gas costs**<br/>
> Fuzzing can lead differences in gas costs estimated each time a test suite is ran. We thus recommend setting a deterministic fuzzing seed via the `--fuzz-seed` argument.

This repository is maintained independently from [Foundry](https://github.com/foundry-rs/foundry) and may not work as expected with all versions of `forge`.
